// pecco -- please enjoy classification with conjunctive features
//  $Id: pecco_conf.h 569 2011-08-29 12:42:56Z ynaga $
// Copyright (c) 2008-2011 Naoki Yoshinaga <ynaga@tkl.iis.u-tokyo.ac.jp>
#ifndef PECCO_CONFIG_H
#define PECCO_CONFIG_H
// configure options for pecco

// use float as the type of weights
// Effect: increase negligible rounding errors and slight speed up ~10%
// #define USE_FLOAT

// encode weights into a trie in polyk; enables USE_FLOAT
// EFFECT: improve both speed- and time- efficiency of the polyk classifier
//         increase rounding errors
// #define ABUSE_TRIE

// rename features according to their frequency counts
//   in the training data (USE_FREQ_SORT), or
//   in the support vectors / conjunctive features (USE_UNIT_SORT)
// EFFECT: the choice itself does not have a difference but either should be set
//         for pke, split and fst classifiers
#define USE_FREQ_SORT
// #define USE_UNIT_SORT

// double array library used to store conjunctive features and feature sequences
//   - Darts-Clone by Yata (USE_DARTS_CLONE; highly recommended), or
//   - Darts by Kudo (USE_DARTS)
//   - CEDAR (USE_CEDAR)
// EFFECT: Darts-Clone requires 1/2 to 1/3 memory compared to others and is 
//         highly recommended; either should be set
// #define USE_DARTS
#define USE_DARTS_CLONE
// #define USE_CEDAR

// use TR1 unordered_map / unordered_set for map / set type
// EFFECT: slightly speeding up the initialization
#ifndef USE_HASH
#define USE_HASH
#endif

// use RDTSC to compute timinigs
// EFFECT: report training and test time (overhead is negligible)
//         disable this options improves pa.h portability
//          
// #ifndef USE_TIMER
// #define USE_TIMER
// #endif

#endif /* PECCO_CONFIG_H */
